////////////////////////////////////////////////////////////////////
//
// Copyright (C) Decision Computer International Co., Ltd 
//
//         Decision Library (DecLib Library) v3.0
//
// # Modual Name: DecLib.h
//
// # Abstract: Main Header file for DecLib.dll
// 
////////////////////////////////////////////////////////////////////

#define CDEVICELIB_EXPORTS

#ifdef CDEVICELIB_EXPORTS
#define CDEVICELIB_API __declspec(dllexport)
#else
#define CDEVICELIB_API __declspec(dllimport)
#endif

#if !defined(AFX_DECLIB_H__399A8174_B02D_4493_AFDE_DE52E924A525__INCLUDED_)
#define AFX_DECLIB_H__399A8174_B02D_4493_AFDE_DE52E924A525__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

/******************************************************************************
******************************************************************************/

// =========================================================================
//               device type definition
// =========================================================================

#define DECISION_PCI_IND_CARD		0x0001
#define DECISION_PCI_8255_CARD		0x0002
#define DECISION_PCI_4P4R_CARD		0x0003
#define DECISION_PCI_8P8R_CARD		0x0004
#define DECISION_PCI_16P16R_CARD	0x0005
#define DECISION_PCI_M8255_CARD		0x0007
#define DECISION_PCI_12ADDA_CARD	0x0008
#define DECISION_PCI_14ADDA_CARD	0x0009


// =========================================================================
//               Function Prototype (Application Program Interface)
// =========================================================================
// -------------------------------------------------------------------------
//					Functions to open and close Devices
// -------------------------------------------------------------------------
// open device port
extern "C" CDEVICELIB_API BOOL WINAPI OpenDecPort(void);

// Close all device port
extern "C" CDEVICELIB_API void WINAPI CloseDecPort(void);

// Close one device port
extern "C" CDEVICELIB_API BOOL WINAPI CloseDevice (unsigned short); // device base address
																	// return: TRUE if successfully

// -------------------------------------------------------------------------
//					Functions to get device base address
// ------------------------------------------------------------------------- 
//  get device address (user provides device type)
extern "C" CDEVICELIB_API BOOL WINAPI GetDevicePortAddress(unsigned int,      // card type     
														   unsigned short*);  // buffer for storing address
																			  // return: TRUE if successfully

// get device address (user provides nothing)
extern "C" CDEVICELIB_API BOOL WINAPI GetDevicePortAddressEx(unsigned short*);  // buffer for storing address
																				// return: TRUE if successfully

// get device address (user provide device type and device index)
extern "C" CDEVICELIB_API BOOL WINAPI GetDevicePortAddressEx2(unsigned int,      // device type
															  unsigned int,      // device index (reference the index on Control Panel)
															  unsigned short*);  // buufer for storing address
																				 // return: TRUE if successfully																		
// get device address (user provide device name)
extern "C" CDEVICELIB_API BOOL WINAPI GetDevicePortAddressEx3(LPTSTR         lpszDeviceName,  // device name
												   			  unsigned short *pusAddress);    // device base address
																							  // return: TRUE if successfully

// -------------------------------------------------------------------------
//					Functions to device I/O
// ------------------------------------------------------------------------- 
// output byte-data to device
extern "C" CDEVICELIB_API BOOL WINAPI outportb(unsigned short,  // address to write
											   unsigned char);  // data to write
                                                                // return: TRUE if successfully

// output 2-byte-data to device
extern "C" CDEVICELIB_API BOOL WINAPI outport(unsigned short,   // address to write
											  unsigned short);  // data to write
                                                                // return: TRUE if successfully

// input byte-data from device
extern "C" CDEVICELIB_API unsigned char WINAPI inportb(unsigned short);  // address to read
																		 // return: TRUE if successfully

// input 2-byte-data from device
extern "C" CDEVICELIB_API unsigned short WINAPI inport(unsigned short);  // address to read
																		 // return: TRUE if successfully


		
#endif // !defined(AFX_DECLIB_H__399A8174_B02D_4493_AFDE_DE52E924A525__INCLUDED_)
